/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables;


import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Indexes;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Keys;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.records.PerfConfigurationSettingsRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class PerfConfigurationSettings extends TableImpl<PerfConfigurationSettingsRecord> {

    private static final long serialVersionUID = 919959020;

    /**
     * The reference instance of <code>PERF_CONFIGURATION_SETTINGS</code>
     */
    public static final PerfConfigurationSettings PERF_CONFIGURATION_SETTINGS = new PerfConfigurationSettings();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<PerfConfigurationSettingsRecord> getRecordType() {
        return PerfConfigurationSettingsRecord.class;
    }

    /**
     * The column <code>PERF_CONFIGURATION_SETTINGS.CONFIGURATION_ID</code>.
     */
    public final TableField<PerfConfigurationSettingsRecord, Integer> CONFIGURATION_ID = createField("CONFIGURATION_ID", org.jooq.impl.SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>PERF_CONFIGURATION_SETTINGS.SETTINGS_ID</code>.
     */
    public final TableField<PerfConfigurationSettingsRecord, Integer> SETTINGS_ID = createField("SETTINGS_ID", org.jooq.impl.SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * Create a <code>PERF_CONFIGURATION_SETTINGS</code> table reference
     */
    public PerfConfigurationSettings() {
        this(DSL.name("PERF_CONFIGURATION_SETTINGS"), null);
    }

    /**
     * Create an aliased <code>PERF_CONFIGURATION_SETTINGS</code> table reference
     */
    public PerfConfigurationSettings(String alias) {
        this(DSL.name(alias), PERF_CONFIGURATION_SETTINGS);
    }

    /**
     * Create an aliased <code>PERF_CONFIGURATION_SETTINGS</code> table reference
     */
    public PerfConfigurationSettings(Name alias) {
        this(alias, PERF_CONFIGURATION_SETTINGS);
    }

    private PerfConfigurationSettings(Name alias, Table<PerfConfigurationSettingsRecord> aliased) {
        this(alias, aliased, null);
    }

    private PerfConfigurationSettings(Name alias, Table<PerfConfigurationSettingsRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> PerfConfigurationSettings(Table<O> child, ForeignKey<O, PerfConfigurationSettingsRecord> key) {
        super(child, key, PERF_CONFIGURATION_SETTINGS);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.PERF_CONFIGURATION_SETTINGS_PERF_CONFIGURATION_SETTINGS_IDX1, Indexes.PERF_CONFIGURATION_SETTINGS_PRIMARY, Indexes.PERF_CONFIGURATION_SETTINGS_SETTINGS_ID);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<PerfConfigurationSettingsRecord> getPrimaryKey() {
        return Keys.KEY_PERF_CONFIGURATION_SETTINGS_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<PerfConfigurationSettingsRecord>> getKeys() {
        return Arrays.<UniqueKey<PerfConfigurationSettingsRecord>>asList(Keys.KEY_PERF_CONFIGURATION_SETTINGS_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<PerfConfigurationSettingsRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<PerfConfigurationSettingsRecord, ?>>asList(Keys.PERF_CONFIGURATION_SETTINGS_IBFK_1, Keys.PERF_CONFIGURATION_SETTINGS_IBFK_2);
    }

    public PerfConfiguration perfConfiguration() {
        return new PerfConfiguration(this, Keys.PERF_CONFIGURATION_SETTINGS_IBFK_1);
    }

    public PerfSetting perfSetting() {
        return new PerfSetting(this, Keys.PERF_CONFIGURATION_SETTINGS_IBFK_2);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public PerfConfigurationSettings as(String alias) {
        return new PerfConfigurationSettings(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public PerfConfigurationSettings as(Name alias) {
        return new PerfConfigurationSettings(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public PerfConfigurationSettings rename(String name) {
        return new PerfConfigurationSettings(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public PerfConfigurationSettings rename(Name name) {
        return new PerfConfigurationSettings(name, null);
    }
}
